#!/usr/bin/php
<?php
        //Variable fr den Download-Pfad und eine Variable fr einen "Unattendend-Mode"
        //Bei Full-Auto gibt es keine Augaben mehr, auer ber Erfolg und Misserfolg wird hier nichts mehr berichtet
       $downloadPath = 'C:\pfad\zum\speichern'; // BITTE NDERN \\
       $fullAuto =     false; // Standart = false \\

        //Checken, ob $downloadPath überhaupt existiert
	if(!is_dir($downloadPath))
	{
                echo "Es tut mir leid, aber der Downloadpfad, den Sie angegeben haben\nscheint inkorrekt zu sein.\nBitte kontrollieren Sie den Pfad noch einmal in der Datei!\n\n  <<Drcken Sie eine beliebige Taste, um das Programm zu verlassen>>";
		fgets(STDIN);
		die();
	}
	
	//Funktion, um XML in einen Array zu parsen
	function xml2array($contents, $get_attributes=1, $priority = 'tag')
	{
	/** 
	 * xml2array() will convert the given XML text to an array in the XML structure. 
	 * Link: http://www.bin-co.com/php/scripts/xml2array/ 
	 * Arguments : $contents - The XML text 
	 *                $get_attributes - 1 or 0. If this is 1 the function will get the attributes as well as the tag values - this results in a different array structure in the return value.
	 *                $priority - Can be 'tag' or 'attribute'. This will change the way the resulting array sturcture. For 'tag', the tags are given more importance.
	 * Return: The parsed XML in an array form. Use print_r() to see the resulting array structure. 
	 * Examples: $array =  xml2array(file_get_contents('feed.xml')); 
	 *              $array =  xml2array(file_get_contents('feed.xml', 1, 'attribute')); 
	 */ 
    if(!$contents) return array(); 

    if(!function_exists('xml_parser_create')) { 
        //print "'xml_parser_create()' function not found!"; 
        return array(); 
    } 

    //Get the XML parser of PHP - PHP must have this module for the parser to work 
    $parser = xml_parser_create(''); 
    xml_parser_set_option($parser, XML_OPTION_TARGET_ENCODING, "UTF-8"); # http://minutillo.com/steve/weblog/2004/6/17/php-xml-and-character-encodings-a-tale-of-sadness-rage-and-data-loss 
    xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0); 
    xml_parser_set_option($parser, XML_OPTION_SKIP_WHITE, 1); 
    xml_parse_into_struct($parser, trim($contents), $xml_values); 
    xml_parser_free($parser); 

    if(!$xml_values) return;//Hmm... 

    //Initializations 
    $xml_array = array(); 
    $parents = array(); 
    $opened_tags = array(); 
    $arr = array(); 

    $current = &$xml_array; //Refference 

    //Go through the tags. 
    $repeated_tag_index = array();//Multiple tags with same name will be turned into an array 
    foreach($xml_values as $data) { 
        unset($attributes,$value);//Remove existing values, or there will be trouble 

        //This command will extract these variables into the foreach scope 
        // tag(string), type(string), level(int), attributes(array). 
        extract($data);//We could use the array by itself, but this cooler. 

        $result = array(); 
        $attributes_data = array(); 

        if(isset($value)) { 
            if($priority == 'tag') $result = $value; 
            else $result['value'] = $value; //Put the value in a assoc array if we are in the 'Attribute' mode 
        } 

        //Set the attributes too. 
        if(isset($attributes) and $get_attributes) { 
            foreach($attributes as $attr => $val) { 
                if($priority == 'tag') $attributes_data[$attr] = $val; 
                else $result['attr'][$attr] = $val; //Set all the attributes in a array called 'attr' 
            } 
        } 

        //See tag status and do the needed. 
        if($type == "open") {//The starting of the tag '<tag>' 
            $parent[$level-1] = &$current; 
            if(!is_array($current) or (!in_array($tag, array_keys($current)))) { //Insert New tag 
                $current[$tag] = $result; 
                if($attributes_data) $current[$tag. '_attr'] = $attributes_data; 
                $repeated_tag_index[$tag.'_'.$level] = 1; 

                $current = &$current[$tag]; 

            } else { //There was another element with the same tag name 

                if(isset($current[$tag][0])) {//If there is a 0th element it is already an array 
                    $current[$tag][$repeated_tag_index[$tag.'_'.$level]] = $result; 
                    $repeated_tag_index[$tag.'_'.$level]++; 
                } else {//This section will make the value an array if multiple tags with the same name appear together 
                    $current[$tag] = array($current[$tag],$result);//This will combine the existing item and the new item together to make an array 
                    $repeated_tag_index[$tag.'_'.$level] = 2; 

                    if(isset($current[$tag.'_attr'])) { //The attribute of the last(0th) tag must be moved as well 
                        $current[$tag]['0_attr'] = $current[$tag.'_attr']; 
                        unset($current[$tag.'_attr']); 
                    } 

                } 
                $last_item_index = $repeated_tag_index[$tag.'_'.$level]-1; 
                $current = &$current[$tag][$last_item_index]; 
            } 

        } elseif($type == "complete") { //Tags that ends in 1 line '<tag />' 
            //See if the key is already taken. 
            if(!isset($current[$tag])) { //New Key 
                $current[$tag] = $result; 
                $repeated_tag_index[$tag.'_'.$level] = 1; 
                if($priority == 'tag' and $attributes_data) $current[$tag. '_attr'] = $attributes_data; 

            } else { //If taken, put all things inside a list(array) 
                if(isset($current[$tag][0]) and is_array($current[$tag])) {//If it is already an array... 

                    // ...push the new element into that array. 
                    $current[$tag][$repeated_tag_index[$tag.'_'.$level]] = $result; 

                    if($priority == 'tag' and $get_attributes and $attributes_data) { 
                        $current[$tag][$repeated_tag_index[$tag.'_'.$level] . '_attr'] = $attributes_data; 
                    } 
                    $repeated_tag_index[$tag.'_'.$level]++; 

                } else { //If it is not an array... 
                    $current[$tag] = array($current[$tag],$result); //...Make it an array using using the existing value and the new value 
                    $repeated_tag_index[$tag.'_'.$level] = 1; 
                    if($priority == 'tag' and $get_attributes) { 
                        if(isset($current[$tag.'_attr'])) { //The attribute of the last(0th) tag must be moved as well 

                            $current[$tag]['0_attr'] = $current[$tag.'_attr']; 
                            unset($current[$tag.'_attr']); 
                        } 

                        if($attributes_data) { 
                            $current[$tag][$repeated_tag_index[$tag.'_'.$level] . '_attr'] = $attributes_data; 
                        } 
                    } 
                    $repeated_tag_index[$tag.'_'.$level]++; //0 and 1 index is already taken 
                } 
            } 

        } elseif($type == 'close') { //End of tag '</tag>' 
            $current = &$parent[$level-1]; 
        } 
    } 

    return($xml_array); 
}
	
	//Funktion, um den Bildschirm unter Unix/Linux als auch unter OS X und Windows zu leeren
	function cls()
	{
		if (strtoupper(substr(php_uname('s'), 0, 3)) === 'WIN')
		{
			shell_exec('cls');
		}
		else
		{
			passthru('clear');
		}
	}
	
        //Bildschirm aufrumen
	cls();
	
        //Datei fr den Stream includieren und in einen Array parsen
	$file_raw = file_get_contents('http://www.cczwei.de/rss_tvissues_all.php');
	$file = xml2array($file_raw, 0);
	
        //Variablen fr die Ursprung-URL der Folgen als auch die Anzahl der Folgen und einer Variable fr Folgen, die bereits geladen wurden.
	$baseURL = 'http://cczwei.mirror.speedpartner.de/cc2tv/';
	
	$folgenOriginal = (string) count($file['rss']['channel']['item']);
	$folgen = (string) count($file['rss']['channel']['item']);
	
	$alreadyDownloaded = '';
	$howManyAlready = '';
	
	//Willkommensmeldung anzeigen
	if($fullAuto !== true)
	{
                echo "Hallo und herzlichst willkommen in meinem Skript!\n\nMit diesem Script knnen Sie alle Folgen der Serie \"Computer Club 2\"\nherunterladen, oder sie in einem Verzeichnis archivieren und aktuell halten.\n\nDer Downloadvorgang geschieht automatisch; Die Datei(en)\nwird bzw. werden in dem im Skript angegeben Verzeichnis abgelegt.\n\nLange Rede, kurzer Sinn: Haben Sie viel Spa mit meiner Anwendung!\nThomas Keppler - Fan des CC2\nZu erreichen unter: tkeppler@fox-technologies.de\n\n         <<Drcken Sie eine beliebige Taste, um fortzufahren>>\n\n";
                //Auf Eingabe warten und Bildschirm aufrumen
		fgets(STDIN); 
		cls();
	}
	
	//Zwischenmeldung, damit es nicht so langweilig ist
	if($fullAuto !== true)
	{
                echo "Der Downloadvorgang wird nun angestoen,\nDies kann einen Moment dauern, bitte haben Sie Geduld und\nbrechen Sie das Skript nicht ab!!\nDas Skript wird eine Statusmeldung ausgeben, \nsobald eine Folge fertig geladen wurde.\n\n";
	}
	
        //Fr jede Folge (im RSS-Stream des CC2 ist das in items eingeteilt) werden verschiedene Dinge geprft
	foreach($file['rss']['channel']['item'] as $info)
	{
                //Dateiname fr den Existenzcheck bearbeiten
		if(strlen($folgen) > 1)
		{
			$currentFolgeFile = "CC2_0$folgen.mp4";
		}
		else
		{
			$currentFolgeFile = "CC2_00$folgen.mp4";
		}
		
		//Checken, ob die Datei bereits existiert; Wenn nicht, downloaden! =)
		if(file_exists($downloadPath."/$currentFolgeFile"))
		{
                        //Variable fr den Check, ob nicht einfach alle Folgen da sind
			$howManyAlready++;
			//Folgen, die bereits geladen wurden, in eine Variable schreiben
			$alreadyDownloaded .= "$folgen\n";
		}
		else
		{
			//Meldung, dass der Kopiervorgang gestartet wurde
			echo "Download von Folge $folgen erfolgt, bitte warten...\n";
			
			//Kopieranweisungen mit Fehlerbehandlung
			if(!copy($baseURL.$currentFolgeFile, $downloadPath."/$currentFolgeFile"))
			{
                            die("\n   Downloaden von Folge $folgen schlug leider fehl. \nBitte prfen Sie Ihre Internetverbingung,\noder setzen Sie sich mit dem Author in Verbindung\n\nDas Programm wurde abgebrochen.\n\n");
			}
			else
			{
				echo "Folge $folgen konnte erfolgreich heruntergeladen werden! :-) \n\n";
			}
		}
		
		//Folgen um eins runterzählen, um weiterzuarbeiten
		$folgen--;
		
	} //Loop beginnt von vorne, bis alle Folgen auf der Platte existent sind!
	if($fullAuto !== true)
	{
                echo "            Der Download ist beendet.\n\n            <<5 Sek. warten fr die Ergebnisseite...>>\n\n";
		sleep(4);
		cls();
		
                //Bereitsgedownloadete Folgen formatieren
		$alreadyDownloaded = str_replace("\n", ', ', $alreadyDownloaded);
		$alreadyDownloaded = substr($alreadyDownloaded, 0, -2);
	
		//Abschluss und damit Erfolgsmeldung
		if($folgenOriginal == $howManyAlready)
		{
                        echo "   Ergebnis:\n   ---------------\n   Es mussten keine Folgen heruntergeladen werden.\n   Das heit, Ihr Archiv ist aktuell.\n\n   Das Programm wird nun beendet.\n\n         <<Drücken Sie eine beliebige Taste, um fortzufahren>>\n";
			fgets(STDIN); 
			passthru('clear');
		}
		else
		{
                        echo "\n\n   Ergebnis:\n   ---------------\n   Der Downloadvorgang ist abgeschlossen.\n   Folgen $alreadyDownloaded\n   mussten nicht heruntergeladen werden, sie waren bereits vorhanden.\n\n   Das Programm wird nun beendet.\n\n         <<Drcken Sie eine beliebige Taste, um fortzufahren>>\n";
			fgets(STDIN); 
			passthru('clear');
		}
	}
	else
	{
		cls();
	}
